<?php

	# $Id: example_address_qr.php,v 1.8 2007/08/15 06:28:13 asc Exp $

	$inc = ini_get("include_path");
	ini_set("include_path", "{$inc}:./FPDF:./qr");

	include("pmPDF.php");
	include("qr.php");

	$args = array('folds' => 1, 'borders' => 0);
	$pdf = new pmPDF($args);

	$pdf->SetFont('Helvetica');
	$pdf->SetFontSize(10);

	$addr = "475 Sansome\nSan Francisco CA\n94111"; 
	$location = urlencode(str_replace("\n", " ", $addr));

	# 
	
	$zoom = 2;
	$req = "http://api.local.yahoo.com/MapsService/V1/mapImage?appid=YahooDemo&location={$location}&zoom={$zoom}&image_width=500&image_type=png";
	$res = $pdf->simple_get($req);
	$map = new SimpleXMLElement($res);

	$tmp = tempnam("/tmp", time()) . ".png";
	$fh  = fopen($tmp, "w");
	fwrite($fh, $pdf->simple_get($map));
	fclose($fh);

	#

	$zoom = 1;
	$req = "http://api.local.yahoo.com/MapsService/V1/mapImage?appid=YahooDemo&location={$location}&zoom={$zoom}&image_width=500&image_type=png";
	$res = $pdf->simple_get($req);
	$mapsm = new SimpleXMLElement($res);
	$tmpsm = tempnam("/tmp", time()) . "-sm.png";

	$fh  = fopen($tmpsm, "w");
	fwrite($fh, $pdf->simple_get($mapsm));
	fclose($fh);
	
	# 

	$pdf->add_image($tmpsm, 2, array('h' => 1));
	$pdf->add_text($addr, 3);

	$pdf->add_image($tmpsm, 4, array('h' => 1));
	$pdf->add_text($addr, 4, array('x' => 1.25, 'y' => .25));

	$pdf->add_image($tmpsm, 6, array('h' => .75));
	$pdf->add_text($addr, 6, array('x' => 1, 'y' => .25));

	$pdf->add_image($tmpsm, 6, array('y' => 1, 'h' => .75));
	$pdf->add_text($addr, 6,  array('x' => 1, 'y' => 1.25,'resume' => false));

	$pdf->add_image($tmpsm, 6, array('y' => 2, 'h' => .75));
	$pdf->add_text($addr, 6, array('x' => 1, 'y' => 2.25, 'resume' => false));

	$res = $pdf->add_image($tmp, 7);
	$pdf->add_text($addr, 7, array('y' => $res['y']));

	#

	$qr_path = tempnam("/tmp", "qr-" . time()) . ".png";
	$qrg_path = tempnam("/tmp", "qrg-" . time()) . ".png";

	$qr_init = array(
		      'data' => './qr/data',
		      'images' => './qr/image',
		      );

	$qr = new QR($qr_init);

	$qr->encode(array(
		'd' => $addr,
		'path' => $qr_path,
		'color' => array(47, 79, 79),
	));

	$qrg = new QR($qr_init);

	$qrg->encode(array(
		'd' => geospum($location, $pdf),
		'path' => $qrg_path,
		'color' => array(69, 139, 0),
	));

	# 

	# $pdf->add_image($qr_path, 7, array('y' => 2.5, 'x' => 1.75, 'h' => .5));
	# $pdf->add_image($qrg_path, 7, array('y' => 2.5, 'x' => 1.25, 'h' => .5));

	$pdf->add_image($qr_path, 7, array('y' => 2.3, 'x' => 1.75, 'h' => .5));
	$pdf->add_image($qrg_path, 7, array('y' => 2.8, 'x' => 1.75, 'h' => .5));

	$pdf->Output();
	unlink($tmp);

	# 

	function geocode($loc, &$pdf){

		$url = "http://api.local.yahoo.com/MapsService/V1/geocode?appid=YahooDemo&location={$loc}";
		$res = $pdf->simple_get($url);

                $doc = new SimpleXMLElement($res);

                $lat = $doc->Result[0]->Latitude;
                $lon = $doc->Result[0]->Longitude;

		return array($lat, $lon);
	}

	#

	function geospum($loc, &$pdf){
		list($lat, $lon) = geocode($loc, $pdf);
		$url = "http://geo.spum.org/?l={$lat},{$lon}";
		error_log($url);
		return $url;
	}

	#

?>